/* conversation-viewer.c generated by valac 0.56.3, the Vala compiler
 * generated from conversation-viewer.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2016,2019 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include "geary-client-43.0.h"
#include <gee.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <gio/gio.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>

enum  {
	CONVERSATION_VIEWER_0_PROPERTY,
	CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY,
	CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY,
	CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY,
	CONVERSATION_VIEWER_NUM_PROPERTIES
};
static GParamSpec* conversation_viewer_properties[CONVERSATION_VIEWER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ConversationViewerLoadConversationData ConversationViewerLoadConversationData;
typedef struct _Block97Data Block97Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ConversationViewerUpdateFindResultsData ConversationViewerUpdateFindResultsData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block98Data Block98Data;
enum  {
	CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL,
	CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL,
	CONVERSATION_VIEWER_NUM_SIGNALS
};
static guint conversation_viewer_signals[CONVERSATION_VIEWER_NUM_SIGNALS] = {0};

struct _ConversationViewerPrivate {
	ConversationListBox* _current_list;
	ComposerWidget* _current_composer;
	ConversationWebView* _previous_web_view;
	ApplicationConfiguration* config;
	GeeSet* selection_while_composing;
	GCancellable* find_cancellable;
	GtkSpinner* loading_page;
	GtkGrid* no_conversations_page;
	GtkGrid* conversation_page;
	GtkGrid* multiple_conversations_page;
	GtkGrid* empty_folder_page;
	GtkGrid* empty_search_page;
	GtkGrid* composer_page;
	GtkScrolledWindow* conversation_scroller;
	ComponentsEntryUndo* conversation_find_undo;
	GtkButton* conversation_find_next;
	GtkButton* conversation_find_prev;
};

struct _ConversationViewerLoadConversationData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationViewer* self;
	GearyAppConversation* conversation;
	GeeCollection* scroll_to;
	GearyAppEmailStore* store;
	ApplicationContactStore* contacts;
	gboolean start_mark_timer;
	GtkScrolledWindow* old_scroller;
	GtkScrolledWindow* _tmp0_;
	ConversationListBox* new_list;
	ApplicationConfiguration* _tmp1_;
	GtkScrolledWindow* _tmp2_;
	GtkAdjustment* _tmp3_;
	ConversationListBox* _tmp4_;
	ConversationListBox* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	ConversationListBox* _tmp8_;
	ConversationListBoxSearchManager* _tmp9_;
	ConversationListBoxSearchManager* _tmp10_;
	ConversationListBox* _tmp11_;
	GtkGrid* _tmp12_;
	GearySearchQuery* query;
	GearyFolder* _tmp13_;
	GearyFolder* _tmp14_;
	GearyAccount* _tmp15_;
	GearyAccount* _tmp16_;
	GearySearchQuery* _tmp17_;
	GearySearchQuery* _tmp18_;
	GearyAppSearchFolder* search_folder;
	GearyFolder* _tmp19_;
	GearyFolder* _tmp20_;
	GearyAppSearchFolder* _tmp21_;
	GearyAppSearchFolder* _tmp22_;
	GearyAppSearchFolder* _tmp23_;
	GearySearchQuery* _tmp24_;
	GearySearchQuery* _tmp25_;
	GearySearchQuery* _tmp26_;
	ConversationListBox* _tmp27_;
	GearySearchQuery* _tmp28_;
	GtkScrolledWindow* _tmp29_;
	GError* _inner_error0_;
};

struct _Block97Data {
	int _ref_count_;
	ConversationViewer* self;
	ConversationListBox* list;
	gpointer _async_data_;
};

struct _ConversationViewerUpdateFindResultsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ConversationViewer* self;
	Block97Data* _data97_;
	ConversationListBox* _tmp0_;
	ConversationListBox* _tmp1_;
	ConversationListBox* _tmp2_;
	GCancellable* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* cancellable;
	GCancellable* _tmp5_;
	GCancellable* _tmp6_;
	GCancellable* _tmp7_;
	GCancellable* _tmp8_;
	GearySearchQuery* query;
	ConversationListBox* _tmp9_;
	GearyAppConversation* _tmp10_;
	GearyAppConversation* _tmp11_;
	GearyFolder* _tmp12_;
	GearyFolder* _tmp13_;
	GearyAccount* _tmp14_;
	GearyAccount* _tmp15_;
	GearySearchQuery* _tmp16_;
	GearySearchQuery* _tmp17_;
	ConversationListBox* _tmp18_;
	ConversationListBoxSearchManager* _tmp19_;
	ConversationListBoxSearchManager* _tmp20_;
	GearySearchQuery* _tmp21_;
	GError* err;
	GError* _tmp22_;
	const gchar* _tmp23_;
	GError* _inner_error0_;
};

struct _Block98Data {
	int _ref_count_;
	ConversationViewer* self;
	ConversationEmail* email_view;
};

static gint ConversationViewer_private_offset;
static gpointer conversation_viewer_parent_class = NULL;
static GearyBaseInterfaceIface * conversation_viewer_geary_base_interface_parent_iface = NULL;

static void conversation_viewer_set_current_list (ConversationViewer* self,
                                           ConversationListBox* value);
static void conversation_viewer_set_current_composer (ConversationViewer* self,
                                               ComposerWidget* value);
VALA_EXTERN ConversationWebView* conversation_viewer_get_previous_web_view (ConversationViewer* self);
VALA_EXTERN void conversation_viewer_set_previous_web_view (ConversationViewer* self,
                                                ConversationWebView* value);
static void conversation_viewer_new_conversation_scroller (ConversationViewer* self);
static void conversation_viewer_on_composer_closed (ConversationViewer* self);
static void _conversation_viewer_on_composer_closed_composer_box_vanished (ComposerBox* _sender,
                                                                    gpointer self);
static void conversation_viewer_set_visible_child (ConversationViewer* self,
                                            GtkWidget* widget);
static void _conversation_viewer_on_composer_closed_composer_embed_vanished (ComposerEmbed* _sender,
                                                                      gpointer self);
static void conversation_viewer_load_conversation_data_free (gpointer _data);
static gboolean conversation_viewer_load_conversation_co (ConversationViewerLoadConversationData* _data_);
static GtkScrolledWindow* conversation_viewer_remove_current_list (ConversationViewer* self);
static void __lambda155_ (ConversationViewer* self,
                   guint count);
static void ___lambda155__conversation_list_box_search_manager_matches_updated (ConversationListBoxSearchManager* _sender,
                                                                         guint matches,
                                                                         gpointer self);
static void conversation_viewer_add_new_list (ConversationViewer* self,
                                       ConversationListBox* list);
static GearySearchQuery* conversation_viewer_get_find_search_query (ConversationViewer* self,
                                                             GearyAccount* account,
                                                             GError** error);
static void conversation_viewer_load_conversation_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static gboolean conversation_viewer_on_conversation_scroll (ConversationViewer* self);
static gboolean _conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                              GdkEventScroll* event,
                                                                              gpointer self);
static gboolean _conversation_viewer_on_conversation_scroll_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                      GdkEventButton* event,
                                                                                      gpointer self);
static void conversation_viewer_update_find_results_data_free (gpointer _data);
static void conversation_viewer_update_find_results (ConversationViewer* self,
                                              GAsyncReadyCallback _callback_,
                                              gpointer _user_data_);
static void conversation_viewer_update_find_results_finish (ConversationViewer* self,
                                                     GAsyncResult* _res_);
static gboolean conversation_viewer_update_find_results_co (ConversationViewerUpdateFindResultsData* _data_);
static Block97Data* block97_data_ref (Block97Data* _data97_);
static void block97_data_unref (void * _userdata_);
static void ___lambda156_ (Block97Data* _data97_);
static void ____lambda156__g_cancellable_cancelled (GCancellable* _sender,
                                             gpointer self);
static void conversation_viewer_update_find_results_ready (GObject* source_object,
                                                    GAsyncResult* _res_,
                                                    gpointer _user_data_);
static void conversation_viewer_on_find_mode_changed (ConversationViewer* self,
                                               GObject* obj,
                                               GParamSpec* param);
static Block98Data* block98_data_ref (Block98Data* _data98_);
static void block98_data_unref (void * _userdata_);
static void _____lambda157_ (Block98Data* _data98_,
                      GObject* obj,
                      GAsyncResult* res);
static void ______lambda157__gasync_ready_callback (GObject* source_object,
                                             GAsyncResult* res,
                                             gpointer self);
static void _conversation_viewer_on_find_mode_changed_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void conversation_viewer_on_find_text_changed (ConversationViewer* self,
                                               GtkSearchEntry* entry);
static void _conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                gpointer self);
static void conversation_viewer_on_find_next (ConversationViewer* self,
                                       GtkWidget* entry);
static void _conversation_viewer_on_find_next_gtk_button_activate (GtkButton* _sender,
                                                            gpointer self);
static void conversation_viewer_on_find_prev (ConversationViewer* self,
                                       GtkWidget* entry);
static void _conversation_viewer_on_find_prev_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self);
static void conversation_viewer_finalize (GObject * obj);
static GType conversation_viewer_get_type_once (void);
static void _vala_conversation_viewer_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_conversation_viewer_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
conversation_viewer_get_instance_private (ConversationViewer* self)
{
	return G_STRUCT_MEMBER_P (self, ConversationViewer_private_offset);
}

ConversationListBox*
conversation_viewer_get_current_list (ConversationViewer* self)
{
	ConversationListBox* result;
	ConversationListBox* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 278 "conversation-viewer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	return self ? g_object_ref (self) : NULL;
#line 286 "conversation-viewer.c"
}

static void
conversation_viewer_set_current_list (ConversationViewer* self,
                                      ConversationListBox* value)
{
	ConversationListBox* old_value;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_current_list (self);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 300 "conversation-viewer.c"
		ConversationListBox* _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_current_list);
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_current_list = _tmp0_;
#line 19 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY]);
#line 310 "conversation-viewer.c"
	}
}

ComposerWidget*
conversation_viewer_get_current_composer (ConversationViewer* self)
{
	ComposerWidget* result;
	ComposerWidget* _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_composer;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 327 "conversation-viewer.c"
}

static void
conversation_viewer_set_current_composer (ConversationViewer* self,
                                          ComposerWidget* value)
{
	ComposerWidget* old_value;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_current_composer (self);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 341 "conversation-viewer.c"
		ComposerWidget* _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_current_composer);
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_current_composer = _tmp0_;
#line 24 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY]);
#line 351 "conversation-viewer.c"
	}
}

ConversationWebView*
conversation_viewer_get_previous_web_view (ConversationViewer* self)
{
	ConversationWebView* result;
	ConversationWebView* _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_previous_web_view;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 368 "conversation-viewer.c"
}

void
conversation_viewer_set_previous_web_view (ConversationViewer* self,
                                           ConversationWebView* value)
{
	ConversationWebView* old_value;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_value = conversation_viewer_get_previous_web_view (self);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (old_value != value) {
#line 382 "conversation-viewer.c"
		ConversationWebView* _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->_previous_web_view);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->_previous_web_view = _tmp0_;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_notify_by_pspec ((GObject *) self, conversation_viewer_properties[CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY]);
#line 392 "conversation-viewer.c"
	}
}

/**
     * Constructs a new conversation view instance.
     */
ConversationViewer*
conversation_viewer_construct (GType object_type,
                               ApplicationConfiguration* config)
{
	ConversationViewer * self = NULL;
	ApplicationConfiguration* _tmp0_;
	ComponentsPlaceholderPane* no_conversations = NULL;
	ComponentsPlaceholderPane* _tmp1_;
	GtkGrid* _tmp2_;
	ComponentsPlaceholderPane* multi_conversations = NULL;
	ComponentsPlaceholderPane* _tmp3_;
	GtkGrid* _tmp4_;
	ComponentsPlaceholderPane* empty_folder = NULL;
	ComponentsPlaceholderPane* _tmp5_;
	GtkGrid* _tmp6_;
	ComponentsPlaceholderPane* empty_search = NULL;
	ComponentsPlaceholderPane* _tmp7_;
	GtkGrid* _tmp8_;
	GtkSearchEntry* _tmp9_;
	ComponentsEntryUndo* _tmp10_;
	GtkSearchBar* _tmp11_;
	GtkSearchEntry* _tmp12_;
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (APPLICATION_IS_CONFIGURATION (config), NULL);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = (ConversationViewer*) g_object_new (object_type, NULL);
#line 76 "../src/client/conversation-viewer/conversation-viewer.vala"
	geary_base_interface_base_ref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 77 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (config);
#line 77 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->config);
#line 77 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->config = _tmp0_;
#line 79 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = components_placeholder_pane_new ();
#line 79 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp1_);
#line 79 "../src/client/conversation-viewer/conversation-viewer.vala"
	no_conversations = _tmp1_;
#line 81 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_icon_name (no_conversations, "folder-symbolic");
#line 84 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_title (no_conversations, _ ("No conversations selected"));
#line 87 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_subtitle (no_conversations, _ ("Selecting a conversation from the list will display it here"));
#line 90 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = self->priv->no_conversations_page;
#line 90 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (no_conversations, gtk_widget_get_type (), GtkWidget));
#line 92 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = components_placeholder_pane_new ();
#line 92 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp3_);
#line 92 "../src/client/conversation-viewer/conversation-viewer.vala"
	multi_conversations = _tmp3_;
#line 94 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_icon_name (multi_conversations, "folder-symbolic");
#line 97 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_title (multi_conversations, _ ("Multiple conversations selected"));
#line 100 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_subtitle (multi_conversations, _ ("Choosing an action will apply to all selected conversations"));
#line 103 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->multiple_conversations_page;
#line 103 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (multi_conversations, gtk_widget_get_type (), GtkWidget));
#line 105 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = components_placeholder_pane_new ();
#line 105 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp5_);
#line 105 "../src/client/conversation-viewer/conversation-viewer.vala"
	empty_folder = _tmp5_;
#line 107 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_icon_name (empty_folder, "folder-symbolic");
#line 110 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_title (empty_folder, _ ("No conversations found"));
#line 113 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_subtitle (empty_folder, _ ("This folder does not contain any conversations"));
#line 116 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->empty_folder_page;
#line 116 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (empty_folder, gtk_widget_get_type (), GtkWidget));
#line 118 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = components_placeholder_pane_new ();
#line 118 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp7_);
#line 118 "../src/client/conversation-viewer/conversation-viewer.vala"
	empty_search = _tmp7_;
#line 120 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_icon_name (empty_search, "folder-symbolic");
#line 123 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_title (empty_search, _ ("No conversations found"));
#line 126 "../src/client/conversation-viewer/conversation-viewer.vala"
	components_placeholder_pane_set_subtitle (empty_search, _ ("Your search returned no results, try refining your search terms"));
#line 129 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp8_ = self->priv->empty_search_page;
#line 129 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (empty_search, gtk_widget_get_type (), GtkWidget));
#line 131 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp9_ = self->conversation_find_entry;
#line 131 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp10_ = components_entry_undo_new (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_entry_get_type (), GtkEntry));
#line 131 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_find_undo);
#line 131 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->conversation_find_undo = _tmp10_;
#line 136 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_new_conversation_scroller (self);
#line 139 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp11_ = self->conversation_find_bar;
#line 139 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp12_ = self->conversation_find_entry;
#line 139 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_search_bar_connect_entry (_tmp11_, G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_entry_get_type (), GtkEntry));
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (empty_search);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (empty_folder);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (multi_conversations);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (no_conversations);
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	return self;
#line 523 "conversation-viewer.c"
}

ConversationViewer*
conversation_viewer_new (ApplicationConfiguration* config)
{
#line 75 "../src/client/conversation-viewer/conversation-viewer.vala"
	return conversation_viewer_construct (TYPE_CONVERSATION_VIEWER, config);
#line 531 "conversation-viewer.c"
}

/**
     * Puts the view into composer mode, showing a full-height composer.
     */
static void
_conversation_viewer_on_composer_closed_composer_box_vanished (ComposerBox* _sender,
                                                               gpointer self)
{
#line 163 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_composer_closed ((ConversationViewer*) self);
#line 543 "conversation-viewer.c"
}

void
conversation_viewer_do_compose (ConversationViewer* self,
                                ComposerWidget* composer)
{
	ApplicationMainWindow* main_window = NULL;
	GtkWidget* _tmp0_;
	ApplicationMainWindow* _tmp1_;
	ApplicationMainWindow* _tmp2_;
#line 149 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 149 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 150 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 150 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp0_) ? ((ApplicationMainWindow*) _tmp0_) : NULL);
#line 150 "../src/client/conversation-viewer/conversation-viewer.vala"
	main_window = _tmp1_;
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = main_window;
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 568 "conversation-viewer.c"
		ComposerBox* box = NULL;
		ApplicationMainWindow* _tmp3_;
		ComponentsMainToolbar* _tmp4_;
		ComponentsMainToolbar* _tmp5_;
		ComposerBox* _tmp6_;
		ConversationListView* conversation_list = NULL;
		ApplicationMainWindow* _tmp7_;
		ConversationListView* _tmp8_;
		ConversationListView* _tmp9_;
		ConversationListView* _tmp10_;
		ConversationListView* _tmp11_;
		GeeSet* _tmp12_;
		ConversationListView* _tmp13_;
		GtkTreeSelection* _tmp14_;
		ComposerBox* _tmp15_;
		GtkGrid* _tmp16_;
		ComposerBox* _tmp17_;
		GtkGrid* _tmp18_;
#line 152 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = main_window;
#line 152 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = application_main_window_get_main_toolbar (_tmp3_);
#line 152 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = _tmp4_;
#line 152 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = composer_box_new (composer, _tmp5_);
#line 152 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_ref_sink (_tmp6_);
#line 152 "../src/client/conversation-viewer/conversation-viewer.vala"
		box = _tmp6_;
#line 155 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_composer (self, composer);
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp7_ = main_window;
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = application_main_window_get_conversation_list_view (_tmp7_);
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = _tmp8_;
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp10_ = _g_object_ref0 (_tmp9_);
#line 159 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list = _tmp10_;
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp11_ = conversation_list;
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp12_ = conversation_list_view_copy_selected (_tmp11_);
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->selection_while_composing);
#line 160 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->selection_while_composing = _tmp12_;
#line 161 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp13_ = conversation_list;
#line 161 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp14_ = gtk_tree_view_get_selection (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_tree_view_get_type (), GtkTreeView));
#line 161 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_tree_selection_unselect_all (_tmp14_);
#line 163 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp15_ = box;
#line 163 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_connect_object (_tmp15_, "vanished", (GCallback) _conversation_viewer_on_composer_closed_composer_box_vanished, self, 0);
#line 164 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp16_ = self->priv->composer_page;
#line 164 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp17_ = box;
#line 164 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_widget_get_type (), GtkWidget));
#line 165 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp18_ = self->priv->composer_page;
#line 165 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget));
#line 166 "../src/client/conversation-viewer/conversation-viewer.vala"
		composer_widget_update_window_title (composer);
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (conversation_list);
#line 151 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (box);
#line 645 "conversation-viewer.c"
	}
#line 149 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (main_window);
#line 649 "conversation-viewer.c"
}

/**
     * Puts the view into composer mode, showing an embedded composer.
     */
static void
_conversation_viewer_on_composer_closed_composer_embed_vanished (ComposerEmbed* _sender,
                                                                 gpointer self)
{
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_composer_closed ((ConversationViewer*) self);
#line 661 "conversation-viewer.c"
}

void
conversation_viewer_do_compose_embedded (ConversationViewer* self,
                                         ComposerWidget* composer,
                                         GearyEmail* referred)
{
	ComposerEmbed* embed = NULL;
	GtkScrolledWindow* _tmp0_;
	ComposerEmbed* _tmp1_;
	ComposerEmbed* _tmp2_;
	gboolean kinetic = FALSE;
	GtkScrolledWindow* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	ConversationListBox* _tmp7_;
	GtkScrolledWindow* _tmp13_;
#line 173 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 173 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (COMPOSER_IS_WIDGET (composer));
#line 173 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail ((referred == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (referred, GEARY_TYPE_EMAIL));
#line 175 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_composer (self, composer);
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_scroller;
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = composer_embed_new (referred, composer, _tmp0_);
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp1_);
#line 176 "../src/client/conversation-viewer/conversation-viewer.vala"
	embed = _tmp1_;
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = embed;
#line 181 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_tmp2_, "vanished", (GCallback) _conversation_viewer_on_composer_closed_composer_embed_vanished, self, 0);
#line 186 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = self->priv->conversation_scroller;
#line 186 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = gtk_scrolled_window_get_kinetic_scrolling (_tmp3_);
#line 186 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = _tmp4_;
#line 186 "../src/client/conversation-viewer/conversation-viewer.vala"
	kinetic = _tmp5_;
#line 187 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (kinetic) {
#line 709 "conversation-viewer.c"
		GtkScrolledWindow* _tmp6_;
#line 187 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = self->priv->conversation_scroller;
#line 187 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_scrolled_window_set_kinetic_scrolling (_tmp6_, FALSE);
#line 715 "conversation-viewer.c"
	}
#line 189 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->_current_list;
#line 189 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp7_ != NULL) {
#line 721 "conversation-viewer.c"
		ConversationListBox* _tmp8_;
		ComposerEmbed* _tmp9_;
		GearyEmailIdentifier* _tmp10_;
		GearyEmailIdentifier* _tmp11_;
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = self->priv->_current_list;
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = embed;
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp10_ = composer_widget_get_saved_id (composer);
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp11_ = _tmp10_;
#line 190 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_add_embedded_composer (_tmp8_, _tmp9_, _tmp11_ != NULL);
#line 194 "../src/client/conversation-viewer/conversation-viewer.vala"
		composer_widget_update_window_title (composer);
#line 738 "conversation-viewer.c"
	}
#line 197 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (kinetic) {
#line 742 "conversation-viewer.c"
		GtkScrolledWindow* _tmp12_;
#line 197 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp12_ = self->priv->conversation_scroller;
#line 197 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_scrolled_window_set_kinetic_scrolling (_tmp12_, TRUE);
#line 748 "conversation-viewer.c"
	}
#line 200 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp13_ = self->priv->conversation_scroller;
#line 200 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (composer, gtk_widget_get_type (), GtkWidget), -1, (gtk_widget_get_allocated_height (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget)) / 3) * 2);
#line 173 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (embed);
#line 756 "conversation-viewer.c"
}

/**
     * Shows the loading UI.
     */
void
conversation_viewer_show_loading (ConversationViewer* self)
{
	GtkSpinner* _tmp0_;
	GtkSpinner* _tmp1_;
#line 208 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 209 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->loading_page;
#line 209 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_spinner_start (_tmp0_);
#line 210 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->loading_page;
#line 210 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 777 "conversation-viewer.c"
}

/**
     * Shows the UI when no conversations have been selected
     */
void
conversation_viewer_show_none_selected (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 216 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 217 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->no_conversations_page;
#line 217 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 793 "conversation-viewer.c"
}

/**
     * Shows the UI when multiple conversations have been selected
     */
void
conversation_viewer_show_multiple_selected (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 223 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 224 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->multiple_conversations_page;
#line 224 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 809 "conversation-viewer.c"
}

/**
     * Shows the empty folder UI.
     */
void
conversation_viewer_show_empty_folder (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 230 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 231 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->empty_folder_page;
#line 231 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 825 "conversation-viewer.c"
}

/**
     * Shows the empty search UI.
     */
void
conversation_viewer_show_empty_search (ConversationViewer* self)
{
	GtkGrid* _tmp0_;
#line 237 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 238 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->empty_search_page;
#line 238 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget));
#line 841 "conversation-viewer.c"
}

/** Shows and focuses the find entry. */
void
conversation_viewer_enable_find (ConversationViewer* self)
{
	GtkSearchBar* _tmp0_;
	GtkSearchEntry* _tmp1_;
#line 242 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 243 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->conversation_find_bar;
#line 243 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_search_bar_set_search_mode (_tmp0_, TRUE);
#line 244 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->conversation_find_entry;
#line 244 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_grab_focus (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget));
#line 860 "conversation-viewer.c"
}

static void
conversation_viewer_load_conversation_data_free (gpointer _data)
{
	ConversationViewerLoadConversationData* _data_;
	_data_ = _data;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_slice_free (ConversationViewerLoadConversationData, _data_);
#line 880 "conversation-viewer.c"
}

void
conversation_viewer_load_conversation (ConversationViewer* self,
                                       GearyAppConversation* conversation,
                                       GeeCollection* scroll_to,
                                       GearyAppEmailStore* store,
                                       ApplicationContactStore* contacts,
                                       gboolean start_mark_timer,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	ConversationViewerLoadConversationData* _data_;
	ConversationViewer* _tmp0_;
	GearyAppConversation* _tmp1_;
	GeeCollection* _tmp2_;
	GearyAppEmailStore* _tmp3_;
	ApplicationContactStore* _tmp4_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (conversation, GEARY_APP_TYPE_CONVERSATION));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (scroll_to, GEE_TYPE_COLLECTION));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (store, GEARY_APP_TYPE_EMAIL_STORE));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (APPLICATION_IS_CONTACT_STORE (contacts));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_slice_new0 (ConversationViewerLoadConversationData);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_viewer_load_conversation_data_free);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->self = _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = _g_object_ref0 (conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->conversation);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->conversation = _tmp1_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->scroll_to);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->scroll_to = _tmp2_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = _g_object_ref0 (store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->store);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->store = _tmp3_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = _g_object_ref0 (contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->contacts);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->contacts = _tmp4_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->start_mark_timer = start_mark_timer;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_load_conversation_co (_data_);
#line 947 "conversation-viewer.c"
}

void
conversation_viewer_load_conversation_finish (ConversationViewer* self,
                                              GAsyncResult* _res_,
                                              GError** error)
{
	ConversationViewerLoadConversationData* _data_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (NULL == _data_) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		return;
#line 962 "conversation-viewer.c"
	}
}

/**
     * Shows a conversation in the viewer.
     */
static void
__lambda155_ (ConversationViewer* self,
              guint count)
{
	gboolean found = FALSE;
	const gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GtkSearchEntry* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
#line 280 "../src/client/conversation-viewer/conversation-viewer.vala"
	found = count > ((guint) 0);
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (found) {
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = TRUE;
#line 985 "conversation-viewer.c"
	} else {
		GtkSearchEntry* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = self->conversation_find_entry;
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_entry_get_type (), GtkEntry));
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _tmp3_;
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = geary_string_is_empty (_tmp4_);
#line 998 "conversation-viewer.c"
	}
#line 283 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp1_) {
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = "edit-find-symbolic";
#line 1004 "conversation-viewer.c"
	} else {
#line 284 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp0_ = "computer-fail-symbolic";
#line 1008 "conversation-viewer.c"
	}
#line 281 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = self->conversation_find_entry;
#line 281 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_entry_set_icon_from_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_entry_get_type (), GtkEntry), GTK_ENTRY_ICON_PRIMARY, _tmp0_);
#line 286 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = self->priv->conversation_find_next;
#line 286 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_widget_get_type (), GtkWidget), found);
#line 287 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->conversation_find_prev;
#line 287 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), found);
#line 1022 "conversation-viewer.c"
}

static void
___lambda155__conversation_list_box_search_manager_matches_updated (ConversationListBoxSearchManager* _sender,
                                                                    guint matches,
                                                                    gpointer self)
{
#line 279 "../src/client/conversation-viewer/conversation-viewer.vala"
	__lambda155_ ((ConversationViewer*) self, matches);
#line 1032 "conversation-viewer.c"
}

static void
conversation_viewer_load_conversation_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	ConversationViewerLoadConversationData* _data_;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = _user_data_;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_source_object_ = source_object;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_res_ = _res_;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_load_conversation_co (_data_);
#line 1049 "conversation-viewer.c"
}

static gboolean
conversation_viewer_load_conversation_co (ConversationViewerLoadConversationData* _data_)
{
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (_data_->_state_) {
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 0:
#line 1059 "conversation-viewer.c"
		goto _state_0;
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 1:
#line 1063 "conversation-viewer.c"
		goto _state_1;
		default:
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_assert_not_reached ();
#line 1068 "conversation-viewer.c"
	}
	_state_0:
#line 259 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp0_ = conversation_viewer_remove_current_list (_data_->self);
#line 259 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->old_scroller = _data_->_tmp0_;
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp1_ = _data_->self->priv->config;
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp2_ = _data_->self->priv->conversation_scroller;
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp3_ = gtk_scrolled_window_get_vadjustment (_data_->_tmp2_);
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp4_ = conversation_list_box_new (_data_->conversation, !_data_->start_mark_timer, _data_->store, _data_->contacts, _data_->_tmp1_, _data_->_tmp3_);
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_data_->_tmp4_);
#line 261 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->new_list = _data_->_tmp4_;
#line 273 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp5_ = _data_->new_list;
#line 273 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_emit (_data_->self, conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL], 0, _data_->_tmp5_);
#line 277 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp6_ = _data_->self->priv->conversation_find_next;
#line 277 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp7_ = _data_->self->priv->conversation_find_prev;
#line 278 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 279 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp8_ = _data_->new_list;
#line 279 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp9_ = conversation_list_box_get_search (_data_->_tmp8_);
#line 279 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 279 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_data_->_tmp10_, "matches-updated", (GCallback) ___lambda155__conversation_list_box_search_manager_matches_updated, _data_->self, 0);
#line 289 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp11_ = _data_->new_list;
#line 289 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_add_new_list (_data_->self, _data_->_tmp11_);
#line 290 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp12_ = _data_->self->priv->conversation_page;
#line 290 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_visible_child (_data_->self, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp12_, gtk_widget_get_type (), GtkWidget));
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp13_ = geary_app_conversation_get_base_folder (_data_->conversation);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp15_ = geary_folder_get_account (_data_->_tmp14_);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp17_ = conversation_viewer_get_find_search_query (_data_->self, _data_->_tmp16_, &_data_->_inner_error0_);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->query = _data_->_tmp17_;
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->new_list);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->old_scroller);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_unref (_data_->_async_result);
#line 294 "../src/client/conversation-viewer/conversation-viewer.vala"
		return FALSE;
#line 1139 "conversation-viewer.c"
	}
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp18_ = _data_->query;
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_tmp18_ == NULL) {
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp19_ = geary_app_conversation_get_base_folder (_data_->conversation);
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp20_ = _data_->_tmp19_;
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp21_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp20_, GEARY_APP_TYPE_SEARCH_FOLDER) ? ((GearyAppSearchFolder*) _data_->_tmp20_) : NULL);
#line 296 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->search_folder = _data_->_tmp21_;
#line 297 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp22_ = _data_->search_folder;
#line 297 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_data_->_tmp22_ != NULL) {
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp23_ = _data_->search_folder;
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp24_ = geary_app_search_folder_get_query (_data_->_tmp23_);
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp25_ = _data_->_tmp24_;
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp26_ = _g_object_ref0 (_data_->_tmp25_);
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->query);
#line 298 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->query = _data_->_tmp26_;
#line 1169 "conversation-viewer.c"
		}
#line 295 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->search_folder);
#line 1173 "conversation-viewer.c"
	}
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp27_ = _data_->new_list;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp28_ = _data_->query;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_state_ = 1;
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_load_conversation (_data_->_tmp27_, _data_->scroll_to, _data_->_tmp28_, conversation_viewer_load_conversation_ready, _data_);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1185 "conversation-viewer.c"
	_state_1:
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_load_conversation_finish (_data_->_tmp27_, _data_->_res_, &_data_->_inner_error0_);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->query);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->new_list);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->old_scroller);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_object_unref (_data_->_async_result);
#line 302 "../src/client/conversation-viewer/conversation-viewer.vala"
		return FALSE;
#line 1203 "conversation-viewer.c"
	}
#line 305 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp29_ = _data_->old_scroller;
#line 305 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp29_, gtk_widget_get_type (), GtkWidget));
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->query);
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->new_list);
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->old_scroller);
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_state_ != 0) {
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1223 "conversation-viewer.c"
		}
	}
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_unref (_data_->_async_result);
#line 250 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1230 "conversation-viewer.c"
}

static void
conversation_viewer_add_new_list (ConversationViewer* self,
                                  ConversationListBox* list)
{
	GtkViewport* viewport = NULL;
	GtkViewport* _tmp0_;
	GtkScrolledWindow* _tmp1_;
#line 309 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 309 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_LIST_BOX (list));
#line 310 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_list (self, list);
#line 311 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (list, gtk_widget_get_type (), GtkWidget));
#line 317 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = (GtkViewport*) gtk_viewport_new (NULL, NULL);
#line 317 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp0_);
#line 317 "../src/client/conversation-viewer/conversation-viewer.vala"
	viewport = _tmp0_;
#line 318 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_widget_get_type (), GtkWidget));
#line 319 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (list, gtk_widget_get_type (), GtkWidget));
#line 321 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->conversation_scroller;
#line 321 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (viewport, gtk_widget_get_type (), GtkWidget));
#line 309 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (viewport);
#line 1264 "conversation-viewer.c"
}

static GtkScrolledWindow*
conversation_viewer_remove_current_list (ConversationViewer* self)
{
	GCancellable* _tmp0_;
	ConversationListBox* _tmp2_;
	GtkScrolledWindow* old_scroller = NULL;
	GtkScrolledWindow* _tmp5_;
	GtkScrolledWindow* _tmp6_;
	GtkGrid* _tmp7_;
	GtkScrolledWindow* result;
#line 325 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 326 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->find_cancellable;
#line 326 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 1283 "conversation-viewer.c"
		GCancellable* _tmp1_;
#line 327 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->priv->find_cancellable;
#line 327 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_cancellable_cancel (_tmp1_);
#line 328 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self->priv->find_cancellable);
#line 328 "../src/client/conversation-viewer/conversation-viewer.vala"
		self->priv->find_cancellable = NULL;
#line 1293 "conversation-viewer.c"
	}
#line 331 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = self->priv->_current_list;
#line 331 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 1299 "conversation-viewer.c"
		ConversationListBox* _tmp3_;
		ConversationListBox* _tmp4_;
#line 332 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = self->priv->_current_list;
#line 332 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_cancel_conversation_load (_tmp3_);
#line 333 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = self->priv->_current_list;
#line 333 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_emit (self, conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL], 0, _tmp4_);
#line 334 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_list (self, NULL);
#line 1312 "conversation-viewer.c"
	}
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp5_ = self->priv->conversation_scroller;
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 337 "../src/client/conversation-viewer/conversation-viewer.vala"
	old_scroller = _tmp6_;
#line 339 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp7_ = self->priv->conversation_page;
#line 339 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (old_scroller, gtk_widget_get_type (), GtkWidget));
#line 340 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_new_conversation_scroller (self);
#line 341 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = old_scroller;
#line 341 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1330 "conversation-viewer.c"
}

static gboolean
_conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                     GdkEventScroll* event,
                                                                     gpointer self)
{
	gboolean result;
	result = conversation_viewer_on_conversation_scroll ((ConversationViewer*) self);
#line 356 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1342 "conversation-viewer.c"
}

static gboolean
_conversation_viewer_on_conversation_scroll_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                             GdkEventButton* event,
                                                                             gpointer self)
{
	gboolean result;
	result = conversation_viewer_on_conversation_scroll ((ConversationViewer*) self);
#line 359 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1354 "conversation-viewer.c"
}

static void
conversation_viewer_new_conversation_scroller (ConversationViewer* self)
{
	GtkScrolledWindow* scroller = NULL;
	GtkScrolledWindow* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkWidget* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkGrid* _tmp4_;
#line 344 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_ref_sink (_tmp0_);
#line 350 "../src/client/conversation-viewer/conversation-viewer.vala"
	scroller = _tmp0_;
#line 351 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget));
#line 351 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_style_context_add_class (_tmp1_, "geary-conversation-scroller");
#line 352 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_set (scroller, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 353 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_hexpand (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget), TRUE);
#line 354 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget), TRUE);
#line 355 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget));
#line 356 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget), "scroll-event", (GCallback) _conversation_viewer_on_conversation_scroll_gtk_widget_scroll_event, self, 0);
#line 359 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = gtk_scrolled_window_get_vscrollbar (scroller);
#line 359 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_signal_connect_object (_tmp2_, "button-release-event", (GCallback) _conversation_viewer_on_conversation_scroll_gtk_widget_button_release_event, self, 0);
#line 362 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = _g_object_ref0 (scroller);
#line 362 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_scroller);
#line 362 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->conversation_scroller = _tmp3_;
#line 363 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->conversation_page;
#line 363 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (scroller, gtk_widget_get_type (), GtkWidget));
#line 344 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (scroller);
#line 1404 "conversation-viewer.c"
}

/**
     * Sets the currently visible page of the stack.
     */
static void
conversation_viewer_set_visible_child (ConversationViewer* self,
                                       GtkWidget* widget)
{
	const gchar* _tmp0_;
	GtkWidget* current = NULL;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GtkGrid* _tmp4_;
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (widget, gtk_widget_get_type ()));
#line 371 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_buildable_get_name (G_TYPE_CHECK_INSTANCE_CAST (widget, gtk_buildable_get_type (), GtkBuildable));
#line 371 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_debug ("conversation-viewer.vala:371: Showing: %s", _tmp0_);
#line 372 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack));
#line 372 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 372 "../src/client/conversation-viewer/conversation-viewer.vala"
	current = _tmp2_;
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp3_ = current;
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp4_ = self->priv->conversation_page;
#line 373 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 1440 "conversation-viewer.c"
		GtkGrid* _tmp5_;
#line 374 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = self->priv->conversation_page;
#line 374 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (widget != G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_widget_get_type (), GtkWidget)) {
#line 1446 "conversation-viewer.c"
			GtkScrolledWindow* _tmp6_;
			GtkScrolledWindow* _tmp7_;
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = conversation_viewer_remove_current_list (self);
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = _tmp6_;
#line 379 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp7_);
#line 1455 "conversation-viewer.c"
		}
	} else {
		GtkWidget* _tmp8_;
		GtkSpinner* _tmp9_;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp8_ = current;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp9_ = self->priv->loading_page;
#line 381 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp8_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_widget_get_type (), GtkWidget)) {
#line 1466 "conversation-viewer.c"
			GtkSpinner* _tmp10_;
#line 384 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = self->priv->loading_page;
#line 384 "../src/client/conversation-viewer/conversation-viewer.vala"
			gtk_spinner_stop (_tmp10_);
#line 1472 "conversation-viewer.c"
		}
	}
#line 386 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_stack_set_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack), widget);
#line 370 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (current);
#line 1479 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_data_free (gpointer _data)
{
	ConversationViewerUpdateFindResultsData* _data_;
	_data_ = _data;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (_data_->self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_slice_free (ConversationViewerUpdateFindResultsData, _data_);
#line 1491 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results (ConversationViewer* self,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_)
{
	ConversationViewerUpdateFindResultsData* _data_;
	ConversationViewer* _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_slice_new0 (ConversationViewerUpdateFindResultsData);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_set_task_data (_data_->_async_result, _data_, conversation_viewer_update_find_results_data_free);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->self = _tmp0_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results_co (_data_);
#line 1515 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_finish (ConversationViewer* self,
                                                GAsyncResult* _res_)
{
	ConversationViewerUpdateFindResultsData* _data_;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1525 "conversation-viewer.c"
}

static Block97Data*
block97_data_ref (Block97Data* _data97_)
{
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_atomic_int_inc (&_data97_->_ref_count_);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	return _data97_;
#line 1535 "conversation-viewer.c"
}

static void
block97_data_unref (void * _userdata_)
{
	Block97Data* _data97_;
	_data97_ = (Block97Data*) _userdata_;
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (g_atomic_int_dec_and_test (&_data97_->_ref_count_)) {
#line 1545 "conversation-viewer.c"
		ConversationViewer* self;
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		self = _data97_->self;
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data97_->list);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_slice_free (Block97Data, _data97_);
#line 1555 "conversation-viewer.c"
	}
}

static void
___lambda156_ (Block97Data* _data97_)
{
	ConversationViewer* self;
	ConversationListBox* _tmp0_;
	ConversationListBoxSearchManager* _tmp1_;
	ConversationListBoxSearchManager* _tmp2_;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = _data97_->self;
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _data97_->list;
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = conversation_list_box_get_search (_tmp0_);
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = _tmp1_;
#line 397 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_list_box_search_manager_cancel (_tmp2_);
#line 1576 "conversation-viewer.c"
}

static void
____lambda156__g_cancellable_cancelled (GCancellable* _sender,
                                        gpointer self)
{
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
	___lambda156_ (self);
#line 1585 "conversation-viewer.c"
}

static void
conversation_viewer_update_find_results_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_)
{
	ConversationViewerUpdateFindResultsData* _data_;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_ = _user_data_;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_source_object_ = source_object;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_res_ = _res_;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results_co (_data_);
#line 1602 "conversation-viewer.c"
}

static gboolean
conversation_viewer_update_find_results_co (ConversationViewerUpdateFindResultsData* _data_)
{
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (_data_->_state_) {
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 0:
#line 1612 "conversation-viewer.c"
		goto _state_0;
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		case 1:
#line 1616 "conversation-viewer.c"
		goto _state_1;
		default:
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_assert_not_reached ();
#line 1621 "conversation-viewer.c"
	}
	_state_0:
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data97_ = g_slice_new0 (Block97Data);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data97_->_ref_count_ = 1;
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data97_->self = g_object_ref (_data_->self);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data97_->_async_data_ = _data_;
#line 390 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp0_ = _data_->self->priv->_current_list;
#line 390 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp1_ = _g_object_ref0 (_data_->_tmp0_);
#line 390 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data97_->list = _data_->_tmp1_;
#line 391 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_tmp2_ = _data_->_data97_->list;
#line 391 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_tmp2_ != NULL) {
#line 392 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp3_ = _data_->self->priv->find_cancellable;
#line 392 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_data_->_tmp3_ != NULL) {
#line 393 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp4_ = _data_->self->priv->find_cancellable;
#line 393 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_cancellable_cancel (_data_->_tmp4_);
#line 1650 "conversation-viewer.c"
		}
#line 395 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp5_ = g_cancellable_new ();
#line 395 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->cancellable = _data_->_tmp5_;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp6_ = _data_->cancellable;
#line 396 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_signal_connect_data (_data_->_tmp6_, "cancelled", (GCallback) ____lambda156__g_cancellable_cancelled, block97_data_ref (_data_->_data97_), (GClosureNotify) block97_data_unref, 0);
#line 399 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp7_ = _data_->cancellable;
#line 399 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->_tmp8_ = _g_object_ref0 (_data_->_tmp7_);
#line 399 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->self->priv->find_cancellable);
#line 399 "../src/client/conversation-viewer/conversation-viewer.vala"
		_data_->self->priv->find_cancellable = _data_->_tmp8_;
#line 1668 "conversation-viewer.c"
		{
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp9_ = _data_->_data97_->list;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp10_ = conversation_list_box_get_conversation (_data_->_tmp9_);
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp12_ = geary_app_conversation_get_base_folder (_data_->_tmp11_);
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp13_ = _data_->_tmp12_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp14_ = geary_folder_get_account (_data_->_tmp13_);
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp15_ = _data_->_tmp14_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp16_ = conversation_viewer_get_find_search_query (_data_->self, _data_->_tmp15_, &_data_->_inner_error0_);
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->query = _data_->_tmp16_;
#line 401 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 1690 "conversation-viewer.c"
				goto __catch0_g_error;
			}
#line 404 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp17_ = _data_->query;
#line 404 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_data_->_tmp17_ != NULL) {
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp18_ = _data_->_data97_->list;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp19_ = conversation_list_box_get_search (_data_->_tmp18_);
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp20_ = _data_->_tmp19_;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_tmp21_ = _data_->query;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				_data_->_state_ = 1;
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list_box_search_manager_highlight_matching_email (_data_->_tmp20_, _data_->_tmp21_, TRUE, conversation_viewer_update_find_results_ready, _data_);
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				return FALSE;
#line 1711 "conversation-viewer.c"
				_state_1:
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list_box_search_manager_highlight_matching_email_finish (_data_->_tmp20_, _data_->_res_, &_data_->_inner_error0_);
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 405 "../src/client/conversation-viewer/conversation-viewer.vala"
					_g_object_unref0 (_data_->query);
#line 1719 "conversation-viewer.c"
					goto __catch0_g_error;
				}
			}
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->query);
#line 1725 "conversation-viewer.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->err = _data_->_inner_error0_;
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_inner_error0_ = NULL;
#line 408 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp22_ = _data_->err;
#line 408 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_tmp23_ = _data_->_tmp22_->message;
#line 408 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_warning ("conversation-viewer.vala:408: Error updating find results: %s", _data_->_tmp23_);
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_error_free0 (_data_->err);
#line 1742 "conversation-viewer.c"
		}
		__finally0:
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_data_->cancellable);
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			block97_data_unref (_data_->_data97_);
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data_->_data97_ = NULL;
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_object_unref (_data_->_async_result);
#line 400 "../src/client/conversation-viewer/conversation-viewer.vala"
			return FALSE;
#line 1761 "conversation-viewer.c"
		}
#line 391 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data_->cancellable);
#line 1765 "conversation-viewer.c"
	}
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	block97_data_unref (_data_->_data97_);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	_data_->_data97_ = NULL;
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_data_->_state_ != 0) {
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1779 "conversation-viewer.c"
		}
	}
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_unref (_data_->_async_result);
#line 389 "../src/client/conversation-viewer/conversation-viewer.vala"
	return FALSE;
#line 1786 "conversation-viewer.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1367 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1368 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1368 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1369 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1370 "glib-2.0.vapi"
	result = _result_;
#line 1370 "glib-2.0.vapi"
	return result;
#line 1807 "conversation-viewer.c"
}

static GearySearchQuery*
conversation_viewer_get_find_search_query (ConversationViewer* self,
                                           GearyAccount* account,
                                           GError** error)
{
	GearySearchQuery* query = NULL;
	GtkSearchBar* _tmp0_;
	GError* _inner_error0_ = NULL;
	GearySearchQuery* result;
#line 413 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), NULL);
#line 413 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (account, GEARY_TYPE_ACCOUNT), NULL);
#line 415 "../src/client/conversation-viewer/conversation-viewer.vala"
	query = NULL;
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->conversation_find_bar;
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (gtk_search_bar_get_search_mode (_tmp0_)) {
#line 1829 "conversation-viewer.c"
		gchar* text = NULL;
		GtkSearchEntry* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->conversation_find_entry;
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = gtk_entry_get_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_entry_get_type (), GtkEntry));
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = string_strip (_tmp2_);
#line 417 "../src/client/conversation-viewer/conversation-viewer.vala"
		text = _tmp3_;
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = text;
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = strlen (_tmp4_);
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp6_ = _tmp5_;
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp6_ >= 2) {
#line 1853 "conversation-viewer.c"
			UtilEmailSearchExpressionFactory* expr_factory = NULL;
			ApplicationConfiguration* _tmp7_;
			GearyAccountInformation* _tmp8_;
			GearyAccountInformation* _tmp9_;
			UtilEmailSearchExpressionFactory* _tmp10_;
			GearySearchQuery* _tmp11_ = NULL;
			UtilEmailSearchExpressionFactory* _tmp12_;
			const gchar* _tmp13_;
			GeeList* _tmp14_;
			GeeList* _tmp15_;
			const gchar* _tmp16_;
			GearySearchQuery* _tmp17_;
			GearySearchQuery* _tmp18_;
			GearySearchQuery* _tmp19_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = self->priv->config;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp8_ = geary_account_get_information (account);
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp9_ = _tmp8_;
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = util_email_search_expression_factory_new (application_configuration_get_search_strategy (_tmp7_), _tmp9_);
#line 422 "../src/client/conversation-viewer/conversation-viewer.vala"
			expr_factory = _tmp10_;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp12_ = expr_factory;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp13_ = text;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp14_ = util_email_search_expression_factory_parse_query (_tmp12_, _tmp13_);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp15_ = _tmp14_;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp16_ = text;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp17_ = geary_account_new_search_query (account, _tmp15_, _tmp16_, &_inner_error0_);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp18_ = _tmp17_;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp15_);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = _tmp18_;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
				g_propagate_error (error, _inner_error0_);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (expr_factory);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_free0 (text);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (query);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
				return NULL;
#line 1908 "conversation-viewer.c"
			}
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp19_ = _tmp11_;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = NULL;
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (query);
#line 426 "../src/client/conversation-viewer/conversation-viewer.vala"
			query = _tmp19_;
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (_tmp11_);
#line 421 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (expr_factory);
#line 1922 "conversation-viewer.c"
		}
#line 416 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_free0 (text);
#line 1926 "conversation-viewer.c"
	}
#line 432 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = query;
#line 432 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 1932 "conversation-viewer.c"
}

static Block98Data*
block98_data_ref (Block98Data* _data98_)
{
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_atomic_int_inc (&_data98_->_ref_count_);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
	return _data98_;
#line 1942 "conversation-viewer.c"
}

static void
block98_data_unref (void * _userdata_)
{
	Block98Data* _data98_;
	_data98_ = (Block98Data*) _userdata_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (g_atomic_int_dec_and_test (&_data98_->_ref_count_)) {
#line 1952 "conversation-viewer.c"
		ConversationViewer* self;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		self = _data98_->self;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (_data98_->email_view);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (self);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_slice_free (Block98Data, _data98_);
#line 1962 "conversation-viewer.c"
	}
}

static void
_____lambda157_ (Block98Data* _data98_,
                 GObject* obj,
                 GAsyncResult* res)
{
	ConversationViewer* self;
	gchar* text = NULL;
	ConversationEmail* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = _data98_->self;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail ((obj == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (res, g_async_result_get_type ()));
#line 444 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = _data98_->email_view;
#line 444 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = conversation_email_get_selection_for_find_finish (_tmp0_, res);
#line 444 "../src/client/conversation-viewer/conversation-viewer.vala"
	text = _tmp1_;
#line 445 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp2_ = text;
#line 445 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp2_ != NULL) {
#line 1992 "conversation-viewer.c"
		GtkSearchEntry* _tmp3_;
		const gchar* _tmp4_;
		GtkSearchEntry* _tmp5_;
#line 446 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = self->conversation_find_entry;
#line 446 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = text;
#line 446 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_entry_set_text (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_entry_get_type (), GtkEntry), _tmp4_);
#line 447 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = self->conversation_find_entry;
#line 447 "../src/client/conversation-viewer/conversation-viewer.vala"
		gtk_editable_select_region (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_editable_get_type (), GtkEditable), 0, -1);
#line 2006 "conversation-viewer.c"
	}
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_free0 (text);
#line 2010 "conversation-viewer.c"
}

static void
______lambda157__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self)
{
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
	_____lambda157_ (self, source_object, res);
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
	block98_data_unref (self);
#line 2022 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_mode_changed (ConversationViewer* self,
                                          GObject* obj,
                                          GParamSpec* param)
{
	ConversationListBox* _tmp0_;
#line 436 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 436 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (obj, G_TYPE_OBJECT));
#line 436 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (param, G_TYPE_PARAM));
#line 437 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 437 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2041 "conversation-viewer.c"
		GtkSearchBar* _tmp1_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->conversation_find_bar;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (gtk_search_bar_get_search_mode (_tmp1_)) {
#line 2047 "conversation-viewer.c"
			Block98Data* _data98_;
			ConversationListBox* _tmp2_;
			ConversationEmail* _tmp3_;
			ConversationEmail* _tmp4_;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data98_ = g_slice_new0 (Block98Data);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data98_->_ref_count_ = 1;
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data98_->self = g_object_ref (self);
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp2_ = self->priv->_current_list;
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp3_ = conversation_list_box_get_selection_view (_tmp2_);
#line 440 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data98_->email_view = _tmp3_;
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp4_ = _data98_->email_view;
#line 442 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp4_ != NULL) {
#line 2068 "conversation-viewer.c"
				ConversationEmail* _tmp5_;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp5_ = _data98_->email_view;
#line 443 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_email_get_selection_for_find (_tmp5_, ______lambda157__gasync_ready_callback, block98_data_ref (_data98_));
#line 2074 "conversation-viewer.c"
			}
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			block98_data_unref (_data98_);
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_data98_ = NULL;
#line 2080 "conversation-viewer.c"
		} else {
			ConversationListBox* _tmp6_;
			ConversationListBoxSearchManager* _tmp7_;
			ConversationListBoxSearchManager* _tmp8_;
			GearyAppSearchFolder* search_folder = NULL;
			ConversationListBox* _tmp9_;
			GearyAppConversation* _tmp10_;
			GearyAppConversation* _tmp11_;
			GearyFolder* _tmp12_;
			GearyFolder* _tmp13_;
			GearyAppSearchFolder* _tmp14_;
			ComponentsEntryUndo* _tmp15_;
			GearyAppSearchFolder* _tmp16_;
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = self->priv->_current_list;
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = conversation_list_box_get_search (_tmp6_);
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp8_ = _tmp7_;
#line 453 "../src/client/conversation-viewer/conversation-viewer.vala"
			conversation_list_box_search_manager_unmark_terms (_tmp8_);
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp9_ = self->priv->_current_list;
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp10_ = conversation_list_box_get_conversation (_tmp9_);
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp11_ = _tmp10_;
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp12_ = geary_app_conversation_get_base_folder (_tmp11_);
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp13_ = _tmp12_;
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, GEARY_APP_TYPE_SEARCH_FOLDER) ? ((GearyAppSearchFolder*) _tmp13_) : NULL);
#line 454 "../src/client/conversation-viewer/conversation-viewer.vala"
			search_folder = _tmp14_;
#line 458 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp15_ = self->priv->conversation_find_undo;
#line 458 "../src/client/conversation-viewer/conversation-viewer.vala"
			components_entry_undo_reset (_tmp15_);
#line 459 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp16_ = search_folder;
#line 459 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp16_ != NULL) {
#line 2124 "conversation-viewer.c"
				GearySearchQuery* query = NULL;
				GearyAppSearchFolder* _tmp17_;
				GearySearchQuery* _tmp18_;
				GearySearchQuery* _tmp19_;
				GearySearchQuery* _tmp20_;
				GearySearchQuery* _tmp21_;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp17_ = search_folder;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp18_ = geary_app_search_folder_get_query (_tmp17_);
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp19_ = _tmp18_;
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 460 "../src/client/conversation-viewer/conversation-viewer.vala"
				query = _tmp20_;
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp21_ = query;
#line 461 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (_tmp21_ != NULL) {
#line 2145 "conversation-viewer.c"
					ConversationListBox* _tmp22_;
					ConversationListBoxSearchManager* _tmp23_;
					ConversationListBoxSearchManager* _tmp24_;
					GearySearchQuery* _tmp25_;
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp22_ = self->priv->_current_list;
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp23_ = conversation_list_box_get_search (_tmp22_);
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp24_ = _tmp23_;
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp25_ = query;
#line 462 "../src/client/conversation-viewer/conversation-viewer.vala"
					conversation_list_box_search_manager_highlight_matching_email (_tmp24_, _tmp25_, TRUE, NULL, NULL);
#line 2160 "conversation-viewer.c"
				}
#line 459 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (query);
#line 2164 "conversation-viewer.c"
			}
#line 438 "../src/client/conversation-viewer/conversation-viewer.vala"
			_g_object_unref0 (search_folder);
#line 2168 "conversation-viewer.c"
		}
	}
}

static void
_conversation_viewer_on_find_mode_changed_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_mode_changed ((ConversationViewer*) self, _sender, pspec);
#line 2180 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_text_changed (ConversationViewer* self,
                                          GtkSearchEntry* entry)
{
	GtkButton* _tmp0_;
	GtkButton* _tmp1_;
#line 473 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 473 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_search_entry_get_type ()));
#line 474 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->conversation_find_next;
#line 474 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 475 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->conversation_find_prev;
#line 475 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget), FALSE);
#line 476 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_update_find_results (self, NULL, NULL);
#line 2203 "conversation-viewer.c"
}

static void
_conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                           gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_text_changed ((ConversationViewer*) self, _sender);
#line 2212 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_next (ConversationViewer* self,
                                  GtkWidget* entry)
{
	ConversationListBox* _tmp0_;
#line 480 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 480 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_widget_get_type ()));
#line 481 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 481 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2228 "conversation-viewer.c"
	}
}

static void
_conversation_viewer_on_find_next_gtk_button_activate (GtkButton* _sender,
                                                       gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_next ((ConversationViewer*) self, _sender);
#line 2238 "conversation-viewer.c"
}

static void
conversation_viewer_on_find_prev (ConversationViewer* self,
                                  GtkWidget* entry)
{
	ConversationListBox* _tmp0_;
#line 487 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 487 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (entry, gtk_widget_get_type ()));
#line 488 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 488 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2254 "conversation-viewer.c"
	}
}

static void
_conversation_viewer_on_find_prev_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_on_find_prev ((ConversationViewer*) self, _sender);
#line 2264 "conversation-viewer.c"
}

static gboolean
conversation_viewer_on_conversation_scroll (ConversationViewer* self)
{
	ConversationListBox* _tmp0_;
	gboolean result;
#line 493 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_val_if_fail (IS_CONVERSATION_VIEWER (self), FALSE);
#line 494 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = self->priv->_current_list;
#line 494 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ != NULL) {
#line 2278 "conversation-viewer.c"
		ConversationListBox* _tmp1_;
#line 495 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp1_ = self->priv->_current_list;
#line 495 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_list_box_mark_visible_read (_tmp1_);
#line 2284 "conversation-viewer.c"
	}
#line 497 "../src/client/conversation-viewer/conversation-viewer.vala"
	result = GDK_EVENT_PROPAGATE;
#line 497 "../src/client/conversation-viewer/conversation-viewer.vala"
	return result;
#line 2290 "conversation-viewer.c"
}

static void
conversation_viewer_on_composer_closed (ConversationViewer* self)
{
	GtkWidget* _tmp0_;
	GtkGrid* _tmp1_;
#line 500 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_return_if_fail (IS_CONVERSATION_VIEWER (self));
#line 501 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_set_current_composer (self, NULL);
#line 502 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp0_ = gtk_stack_get_visible_child (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_stack_get_type (), GtkStack));
#line 502 "../src/client/conversation-viewer/conversation-viewer.vala"
	_tmp1_ = self->priv->composer_page;
#line 502 "../src/client/conversation-viewer/conversation-viewer.vala"
	if (_tmp0_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, gtk_widget_get_type (), GtkWidget)) {
#line 2308 "conversation-viewer.c"
		GtkGrid* _tmp2_;
		ApplicationMainWindow* main_window = NULL;
		GtkWidget* _tmp3_;
		ApplicationMainWindow* _tmp4_;
		ApplicationMainWindow* _tmp5_;
#line 503 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp2_ = self->priv->conversation_page;
#line 503 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_visible_child (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_widget_get_type (), GtkWidget));
#line 506 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp3_ = gtk_widget_get_toplevel (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 506 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp4_ = _g_object_ref0 (APPLICATION_IS_MAIN_WINDOW (_tmp3_) ? ((ApplicationMainWindow*) _tmp3_) : NULL);
#line 506 "../src/client/conversation-viewer/conversation-viewer.vala"
		main_window = _tmp4_;
#line 507 "../src/client/conversation-viewer/conversation-viewer.vala"
		_tmp5_ = main_window;
#line 507 "../src/client/conversation-viewer/conversation-viewer.vala"
		if (_tmp5_ != NULL) {
#line 2328 "conversation-viewer.c"
			ApplicationMainWindow* _tmp6_;
			GeeSet* _tmp7_;
#line 508 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp6_ = main_window;
#line 508 "../src/client/conversation-viewer/conversation-viewer.vala"
			application_main_window_update_title (_tmp6_);
#line 510 "../src/client/conversation-viewer/conversation-viewer.vala"
			_tmp7_ = self->priv->selection_while_composing;
#line 510 "../src/client/conversation-viewer/conversation-viewer.vala"
			if (_tmp7_ != NULL) {
#line 2339 "conversation-viewer.c"
				ConversationListView* conversation_list = NULL;
				ApplicationMainWindow* _tmp8_;
				ConversationListView* _tmp9_;
				ConversationListView* _tmp10_;
				ConversationListView* _tmp11_;
				GeeSet* _tmp12_;
				gboolean _tmp13_;
				gboolean _tmp14_;
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp8_ = main_window;
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp9_ = application_main_window_get_conversation_list_view (_tmp8_);
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp10_ = _tmp9_;
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 511 "../src/client/conversation-viewer/conversation-viewer.vala"
				conversation_list = _tmp11_;
#line 512 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp12_ = self->priv->selection_while_composing;
#line 512 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp13_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_COLLECTION, GeeCollection));
#line 512 "../src/client/conversation-viewer/conversation-viewer.vala"
				_tmp14_ = _tmp13_;
#line 512 "../src/client/conversation-viewer/conversation-viewer.vala"
				if (_tmp14_) {
#line 2366 "conversation-viewer.c"
					ConversationListView* _tmp15_;
					GeeSet* _tmp16_;
#line 513 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp15_ = conversation_list;
#line 513 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp16_ = self->priv->selection_while_composing;
#line 513 "../src/client/conversation-viewer/conversation-viewer.vala"
					g_signal_emit_by_name (_tmp15_, "conversations-selected", _tmp16_);
#line 2375 "conversation-viewer.c"
				} else {
					ConversationListView* _tmp17_;
					GeeSet* _tmp18_;
#line 517 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp17_ = conversation_list;
#line 517 "../src/client/conversation-viewer/conversation-viewer.vala"
					_tmp18_ = self->priv->selection_while_composing;
#line 517 "../src/client/conversation-viewer/conversation-viewer.vala"
					conversation_list_view_select_conversations (_tmp17_, G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection));
#line 2385 "conversation-viewer.c"
				}
#line 522 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (self->priv->selection_while_composing);
#line 522 "../src/client/conversation-viewer/conversation-viewer.vala"
				self->priv->selection_while_composing = NULL;
#line 510 "../src/client/conversation-viewer/conversation-viewer.vala"
				_g_object_unref0 (conversation_list);
#line 2393 "conversation-viewer.c"
			}
		}
#line 502 "../src/client/conversation-viewer/conversation-viewer.vala"
		_g_object_unref0 (main_window);
#line 2398 "conversation-viewer.c"
	}
}

static void
conversation_viewer_class_init (ConversationViewerClass * klass,
                                gpointer klass_data)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_parent_class = g_type_class_peek_parent (klass);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_type_class_adjust_private_offset (klass, &ConversationViewer_private_offset);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_conversation_viewer_get_property;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_conversation_viewer_set_property;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (klass)->finalize = conversation_viewer_finalize;
#line 2416 "conversation-viewer.c"
	/**
	     * The current conversation listbox, if any.
	     */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY] = g_param_spec_object ("current-list", "current-list", "current-list", TYPE_CONVERSATION_LIST_BOX, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2422 "conversation-viewer.c"
	/** Returns the currently displayed composer if any. */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY] = g_param_spec_object ("current-composer", "current-composer", "current-composer", COMPOSER_TYPE_WIDGET, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2426 "conversation-viewer.c"
	/**
	     * The most recent web view created in this viewer.
	     *
	     * Keep the last created web view around so others can share the
	     * same WebKitGTK WebProcess.
	     */
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY, conversation_viewer_properties[CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY] = g_param_spec_object ("previous-web-view", "previous-web-view", "previous-web-view", TYPE_CONVERSATION_WEB_VIEW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/Geary/conversation-viewer.ui");
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_ADDED_SIGNAL] = g_signal_new ("conversation-added", TYPE_CONVERSATION_VIEWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CONVERSATION_LIST_BOX);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_signals[CONVERSATION_VIEWER_CONVERSATION_REMOVED_SIGNAL] = g_signal_new ("conversation-removed", TYPE_CONVERSATION_VIEWER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_CONVERSATION_LIST_BOX);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "loading_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, loading_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "no_conversations_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, no_conversations_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "multiple_conversations_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, multiple_conversations_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "empty_folder_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, empty_folder_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "empty_search_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, empty_search_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "composer_page", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, composer_page));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_bar", FALSE, G_STRUCT_OFFSET (ConversationViewer, conversation_find_bar));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_entry", FALSE, G_STRUCT_OFFSET (ConversationViewer, conversation_find_entry));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_next", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_find_next));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "conversation_find_prev", FALSE, ConversationViewer_private_offset + G_STRUCT_OFFSET (ConversationViewerPrivate, conversation_find_prev));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_mode_changed", G_CALLBACK(_conversation_viewer_on_find_mode_changed_g_object_notify));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_text_changed", G_CALLBACK(_conversation_viewer_on_find_text_changed_gtk_search_entry_search_changed));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_next", G_CALLBACK(_conversation_viewer_on_find_next_gtk_button_activate));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "on_find_prev", G_CALLBACK(_conversation_viewer_on_find_prev_gtk_button_clicked));
#line 69 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "geary-conversation-viewer");
#line 2473 "conversation-viewer.c"
}

static void
conversation_viewer_geary_base_interface_interface_init (GearyBaseInterfaceIface * iface,
                                                         gpointer iface_data)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	conversation_viewer_geary_base_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 2482 "conversation-viewer.c"
}

static void
conversation_viewer_instance_init (ConversationViewer * self,
                                   gpointer klass)
{
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv = conversation_viewer_get_instance_private (self);
#line 18 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_current_list = NULL;
#line 23 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_current_composer = NULL;
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->_previous_web_view = NULL;
#line 37 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->selection_while_composing = NULL;
#line 38 "../src/client/conversation-viewer/conversation-viewer.vala"
	self->priv->find_cancellable = NULL;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2503 "conversation-viewer.c"
}

static void
conversation_viewer_finalize (GObject * obj)
{
	ConversationViewer * self;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 143 "../src/client/conversation-viewer/conversation-viewer.vala"
	geary_base_interface_base_unref (G_TYPE_CHECK_INSTANCE_CAST (self, GEARY_TYPE_BASE_INTERFACE, GearyBaseInterface));
#line 18 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_current_list);
#line 23 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_current_composer);
#line 33 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->_previous_web_view);
#line 35 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->config);
#line 37 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->selection_while_composing);
#line 38 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->find_cancellable);
#line 49 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_scroller);
#line 54 "../src/client/conversation-viewer/conversation-viewer.vala"
	_g_object_unref0 (self->priv->conversation_find_undo);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	G_OBJECT_CLASS (conversation_viewer_parent_class)->finalize (obj);
#line 2532 "conversation-viewer.c"
}

/**
 * Displays the messages in a conversation and in-window composers.
 */
static GType
conversation_viewer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ConversationViewerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) conversation_viewer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConversationViewer), 0, (GInstanceInitFunc) conversation_viewer_instance_init, NULL };
	static const GInterfaceInfo geary_base_interface_info = { (GInterfaceInitFunc) conversation_viewer_geary_base_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType conversation_viewer_type_id;
	conversation_viewer_type_id = g_type_register_static (gtk_stack_get_type (), "ConversationViewer", &g_define_type_info, 0);
	g_type_add_interface_static (conversation_viewer_type_id, GEARY_TYPE_BASE_INTERFACE, &geary_base_interface_info);
	ConversationViewer_private_offset = g_type_add_instance_private (conversation_viewer_type_id, sizeof (ConversationViewerPrivate));
	return conversation_viewer_type_id;
}

GType
conversation_viewer_get_type (void)
{
	static volatile gsize conversation_viewer_type_id__once = 0;
	if (g_once_init_enter (&conversation_viewer_type_id__once)) {
		GType conversation_viewer_type_id;
		conversation_viewer_type_id = conversation_viewer_get_type_once ();
		g_once_init_leave (&conversation_viewer_type_id__once, conversation_viewer_type_id);
	}
	return conversation_viewer_type_id__once;
}

static void
_vala_conversation_viewer_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	ConversationViewer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (property_id) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_current_list (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_current_composer (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		g_value_set_object (value, conversation_viewer_get_previous_web_view (self));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2590 "conversation-viewer.c"
		default:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2596 "conversation-viewer.c"
	}
}

static void
_vala_conversation_viewer_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	ConversationViewer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONVERSATION_VIEWER, ConversationViewer);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
	switch (property_id) {
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_LIST_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_list (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_CURRENT_COMPOSER_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_current_composer (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		case CONVERSATION_VIEWER_PREVIOUS_WEB_VIEW_PROPERTY:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		conversation_viewer_set_previous_web_view (self, g_value_get_object (value));
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2628 "conversation-viewer.c"
		default:
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 13 "../src/client/conversation-viewer/conversation-viewer.vala"
		break;
#line 2634 "conversation-viewer.c"
	}
}

